package net.t2code.alias.Spigot.config.config;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.enums.Confirm;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.system.config.languages.SelectLibMsg;
import org.bukkit.Sound;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class FileSelect {

    private static ArrayList<String> defaultLanguages = new ArrayList<>(Arrays.asList("german", "english"));

    public static void language() {
        long long_ = System.currentTimeMillis();
        for (String language : defaultLanguages) {
            File config = new File(Main.getPath(), "languages/" + language + ".yml");
            YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);
            for (Language value : Language.values()) {
                if (!yamlConfiguration.contains(value.path)) {
                    switch (value.configParam) {
                        case STRING:
                            switch (language) {
                                case "german":
                                    yamlConfiguration.set(value.path, value.german);
                                    break;
                                case "english":
                                    yamlConfiguration.set(value.path, value.english);
                                    break;
                            }
                            break;

                        case LIST:
                            switch (language) {
                                case "german":
                                    yamlConfiguration.set(value.path, value.germanList);
                                    break;
                                case "english":
                                    yamlConfiguration.set(value.path, value.englishList);
                                    break;
                            }
                            break;
                    }
                }
            }
            T2Cdebug.debug(Main.getPlugin(), "save: " + language);
            try {
                yamlConfiguration.save(config);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        String selectMSG;
        File config = new File(Main.getPath(), "languages/" + Config.VALUES.language.getValue() + ".yml");
        T2Cdebug.debug(Main.getPlugin(), config.getAbsolutePath());
        if (!config.isFile()) {
            T2Csend.console(Util.getPrefix());
            T2Csend.console(Util.getPrefix() + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Util.getPrefix() + " §4The selected §c" + Config.VALUES.language.getPath() + " §4language file was not found.");
            T2Csend.console(Util.getPrefix() + " §6The default language §eEnglish §6is used!");
            T2Csend.console(Util.getPrefix() + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Util.getPrefix());
            config = new File(Main.getPath(), "languages/" + "english.yml");
            selectMSG = "english";
        } else selectMSG = (String) Config.VALUES.language.getValue();
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);
        for (Language value : Language.values()) {
            switch (value.configParam) {
                case STRING:
                    T2Cdebug.debug(Main.getPlugin(), "Select: File: " + config.getName() + " Path: " + value.path);
                    value.value = T2Creplace.replace(Util.getPrefix(), yamlConfiguration.getString(value.path));
                    break;

                case LIST:
                    T2Cdebug.debug(Main.getPlugin(), "Select: File: " + config.getName() + " Path: " + value.path);
                    value.valueList = T2Creplace.replace(Util.getPrefix(), (List<String>) yamlConfiguration.getList(value.path));
                    break;
            }
        }
        T2Csend.console(Util.getPrefix() + " §2Language successfully selected to: §6" + selectMSG + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

}
