package net.t2code.alias.Spigot.system;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.cmdManagement.RegisterCommands;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CmcVersion;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandMap;
import org.bukkit.entity.Player;
import org.bukkit.plugin.SimplePluginManager;

import java.lang.reflect.Field;

public class AliasRegister {
    private Main main;

    public AliasRegister (Main main){
        this.main=main;
        loadAliasCommands();
    }

    private void loadAliasCommands() {
        CommandMap commandMap = getCommandMap();

        if (commandMap == null) {
            main. getLogger().severe("CommandMap konnte nicht geladen werden!");
            return;
        }

        for (String alias : Main.allAliases) {
            // Registrieren des Befehls
            Command dynamicCommand = new RegisterCommands(alias);
            commandMap.register(main.getDescription().getName(), dynamicCommand);
            T2Csend.console(Util.getPrefix() + " §aAlias §e" + alias + " §aregister");
        }
    }

    private CommandMap getCommandMap() {
        if (main.getServer().getPluginManager() instanceof SimplePluginManager) {
            SimplePluginManager manager = (SimplePluginManager) main.getServer().getPluginManager();
            try {
                Field field = SimplePluginManager.class.getDeclaredField("commandMap");
                field.setAccessible(true);
                return (CommandMap) field.get(manager);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return null;
    }


}
