package net.t2code.alias.Spigot.system;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.cmdManagement.AliasCmdExecuter;
import net.t2code.alias.Spigot.cmdManagement.TabEvent;
import net.t2code.alias.Spigot.config.alias.CreateExampleAliasConfig;
import net.t2code.alias.Spigot.config.alias.SelectAlias;
import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.config.config.FileSelect;
import net.t2code.alias.Spigot.config.subAlias.CreateExampleSubAliasConfig;
import net.t2code.alias.Spigot.config.subAlias.SelectSubAlias;
import net.t2code.alias.Spigot.confirm.ChatConfirm;
import net.t2code.alias.Spigot.confirm.gui.GuiListener;
import net.t2code.alias.Spigot.enums.Confirm;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.register.T2Cregister;
import net.t2code.t2codelib.SPIGOT.api.update.T2CupdateAPI;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2CLibConfig;
import org.bukkit.Bukkit;
import org.bukkit.event.HandlerList;

import java.io.File;
import java.util.List;

public class Load {
    private static final Main plugin = Main.getPlugin();

    public Load (Main main,String prefix, List<String> autor, String version, String spigot, String discord, int bstatsID){
        onLoad(main, prefix, autor, version, spigot, discord, bstatsID);
    }

    private void onLoad(Main main,String prefix, List<String> autor, String version, String spigot, String discord, int bstatsID) {
        Long long_ = T2Ctemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        plugin.getCommand("t2code-alias").setExecutor(new AliasCmdExecuter());
        loadReload(main);
        T2CupdateAPI.onUpdateCheck(plugin, prefix, Util.getGit(), Util.getSpigotID(), Util.getDiscord(),
                (Boolean) Config.VALUES.updateCheckOnJoin.getValue(), (Boolean) Config.VALUES.updateCheckSeePreReleaseUpdates.getValue(), (Integer) Config.VALUES.updateCheckTimeInterval.getValue());

        T2Ctemplate.onLoadFooter(prefix, long_);
        T2Cregister.listener(new PluginEvents(), plugin);
        Metrics.Bstats(plugin, bstatsID);
    }

    private static ChatConfirm chatListener;
    private static GuiListener guiListener;

    public static void loadReload(Main main) {
        HandlerList.unregisterAll(chatListener);
        HandlerList.unregisterAll(guiListener);
        boolean newInstall = !new File(Main.getPath(), "config.yml").exists();
        Config.set();
        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        FileSelect.language();
        if (newInstall) {
            try {
                CreateExampleAliasConfig.configCreate();
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                CreateExampleSubAliasConfig.configCreate();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        try {
            plugin.saveResource("Alias/X_aliasDeclaration_X.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }
/**
        try {
            plugin.saveResource("X_configDeclaration_X.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }
 */

        try {
            plugin.saveResource("SubAlias/X_subAliasDeclaration_X.yml", true);
        } catch (Exception e) {
            e.printStackTrace();
        }

        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        new SelectAlias(main);
        T2Ctemplate.onLoadSeparateStroke(Util.getPrefix());
        SelectSubAlias.onSelect();
        if ((Boolean) Config.VALUES.subAliasTab.getValue()) {
            T2Cregister.listener(new TabEvent(), plugin);
        }
        chatListener = new ChatConfirm();
        if (Config.VALUES.buyConfirmDefault.getValue() == Confirm.CHAT) T2Cregister.listener(chatListener, plugin);
        guiListener = new GuiListener();
        if (Config.VALUES.buyConfirmDefault.getValue() == Confirm.GUI) T2Cregister.listener(guiListener, plugin);
        if ((boolean)T2CLibConfig.VALUES.proxy.getValue()) {
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2c:bcmd");
        }
        AliasRegisterPermissions.onPermRegister();
    }

}
